.586
.model flat,stdcall
option casemap:none

   include windows.inc
   include user32.inc
   include kernel32.inc
   include gdi32.inc
   include masm32.inc
   include BmpBut.asm
   include sqlite3.inc
   include oleaut32.inc
   include ucmacros.asm
   
   includelib user32.lib
   includelib kernel32.lib
   includelib gdi32.lib
   includelib masm32.lib
   includelib oleaut32.lib
   includelib sqlite3.lib


WinMain          proto :DWORD,:DWORD,:DWORD,:DWORD
to_UTF8          proto :DWORD,:DWORD
UTF8_to          proto :DWORD,:DWORD
create_region    proto :DWORD
EditWndProc      proto :DWORD,:DWORD,:DWORD,:DWORD
edit_proc        proto :DWORD,:DWORD,:DWORD,:DWORD
CallBack         proto :DWORD,:DWORD,:DWORD,:DWORD
SQL_show_number  proto
call_show_number proto :DWORD,:DWORD,:DWORD,:DWORD
DoOpenProfile    proto
DoLoadBut        proto :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
DoLoad           proto :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
edit_proc        proto :DWORD,:DWORD,:DWORD,:DWORD
Search4Skins     proto :DWORD

      CADD       MACRO quoted_text  
        LOCAL vname,lbl
          jmp lbl
            vname db quoted_text,0
          lbl:
        EXITM <ADDR vname>
      ENDM 

      FUNC       MACRO parameters:VARARG
        invoke parameters
        EXITM <eax>
      ENDM

      LOWORD     MACRO bigword
        mov  eax,bigword
        and  eax,0FFFFh     ;; Set to low word
      ENDM

      HIWORD     MACRO bigword
        mov eax,bigword
        shr eax,16
      ENDM

      return     MACRO arg
        mov eax, arg
        ret
	  ENDM
	  
      alloc$ MACRO ln
        invoke SysAllocStringByteLen,0,ln
        mov BYTE PTR [eax], 0
        EXITM <eax>
      ENDM
      	  
      free$ MACRO strhandle
        invoke SysFreeString,strhandle
      ENDM	  
.data
	ClassName db "MainWinClass",0
	AppName   db "Main Window",0
	DBName    db "moby_dic.db",0
	comm1     db "INSERT INTO moby_dic (phrase,trans,examp,asoc) VALUES(",22h,0
	comm2     db 22h,");",0      ;--> "")",0
	comm3     db 22h,",",22h,0     ;--> "","",0
	comm_1    db "SELECT phrase,trans,examp,asoc FROM moby_dic WHERE phrase=='",0
	comm_2    db "'",0
	LF_       db 0Dh,0Ah,0
	hmem1 dd 0
	hmem2 dd 0
	hmem3 dd 0
	hmem4 dd 0
	hmem5 dd 0
	hmem6 dd 0
	hmem7 dd 0
	edit1 dd 0
	edit2 dd 0
	edit3 dd 0
	edit4 dd 0
	edit5 dd 0
	edit6 dd 0
	numb  dd 0
	brush dd 0
	show  dd 0
	menu1 dd 0
	datab dd 0
	lib   dd 0
	but   dd 0 
	but1  dd 0
	but2  dd 0
	but3  dd 0
	OldWndProc dd 0
	hold dd 0
	LF   LOGFONT    <16,10,0,0,400,0,0,0,DEFAULT_CHARSET,0,0,0,0,"Courier New">
	fon  dd 0
	fon1 dd 0
	fon2 dd 0
	fon3 dd 0
	fon4 dd 0
	fon5 dd 0
	fon6 dd 0
	skin byte 128 dup (0)
.data?
   hInstance HINSTANCE ?
   CommandLine LPSTR ?

.code


; ---------------------------------------------------------------------------


start:
	;invoke AddFontResourceEx,CADD("Cybercjk.ttf"), FR_PRIVATE, 0
	
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	
	invoke GetCommandLine
	mov    CommandLine,eax
	
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax
	
	;invoke RemoveFontResourceEx,CADD("Cybercjk.ttf"), FR_PRIVATE, 0
	
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND
	
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, 0
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInstance
	pop   wc.hInstance
	mov   wc.hbrBackground,0
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
	
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	
	invoke RegisterClassEx, addr wc
	INVOKE CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
           WS_POPUP+WS_SYSMENU,100,\
           100,400,400,NULL,NULL,\
           hInst,NULL
	mov   hwnd,eax
	
	invoke ShowWindow, hwnd,SW_SHOWNORMAL
	invoke UpdateWindow, hwnd
	
	.WHILE TRUE
		invoke GetMessage, ADDR msg,NULL,0,0
		.BREAK .IF (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.ENDW
	
	mov     eax,msg.wParam
	ret
WinMain endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL rrgn:DWORD
	LOCAL path[512]:BYTE
	LOCAL ps:PAINTSTRUCT
	LOCAL dc:DWORD
	LOCAL mpt:POINT
	LOCAL errMsg:DWORD
	LOCAL ustr1:DWORD
	LOCAL ustr2:DWORD
	LOCAL ustr3:DWORD
	LOCAL uedx:DWORD
	LOCAL ued:DWORD,ulen:DWORD
	LOCAL ued1:DWORD,ued1_:DWORD,ulen1:DWORD
	LOCAL ued2:DWORD,ued2_:DWORD,ulen2:DWORD
	LOCAL ued3:DWORD,ued3_:DWORD,ulen3:DWORD
	LOCAL ued4:DWORD,ued4_:DWORD,ulen4:DWORD
	
	.IF uMsg==WM_DESTROY
		invoke sqlite3_close,datab
		invoke DeleteDC,hmem1
		invoke DeleteDC,hmem2
		invoke DeleteDC,hmem3
		invoke DeleteDC,hmem4
		invoke DeleteDC,hmem5
		invoke DeleteDC,hmem6
		invoke DeleteObject,fon
		invoke PostQuitMessage,NULL
	.ELSEIF uMsg==WM_COMMAND
		LOWORD wParam
		.if eax==100
			invoke PostMessage,hWnd,WM_SYSCOMMAND,SC_MINIMIZE,0
		.elseif eax==101
			invoke PostMessage,hWnd,WM_SYSCOMMAND,SC_CLOSE,0
		.elseif eax==2001
			invoke CreateRectRgn,0,0,400,400
			invoke SetWindowRgn,hWnd,0,1
		.elseif eax==2002
			invoke create_region,hWnd
		.elseif eax==2000
			invoke GetWindowTextLengthW,edit1
			shl    eax,1
			mov    ulen1,eax
			cmp    ulen1,0
			je     @F
			invoke GetWindowTextLengthW,edit2
			shl    eax,1
			mov    ulen2,eax
			cmp    ulen2,0
			je     @F
			invoke GetWindowTextLengthW,edit3
			shl    eax,1
			mov    ulen3,eax
			inc    ulen3
			invoke GetWindowTextLengthW,edit4
			shl    eax,1
			mov    ulen4,eax
			add    eax,ulen3
			add    eax,ulen2
			add    eax,ulen1
			add    eax,128
			mov    ulen,eax ;number
			;--------------------------------------------
			mov    ued,  alloc$(ulen)  
			
			mov    ued1_, alloc$(ulen1)
			mov    ued1, alloc$(ulen1)
			invoke GetWindowTextW,edit1,ued1_,ulen1
			invoke to_UTF8,ued1_,ued1
			free$  ued1_
			
			mov    ued2_, alloc$(ulen2)
			mov    ued2, alloc$(ulen2)
			invoke GetWindowTextW,edit2,ued2_,ulen2
			invoke to_UTF8,ued2_,ued2
			free$  ued2_
			
			mov    ued3_, alloc$(ulen3)
			mov    ued3, alloc$(ulen3)	
			invoke GetWindowTextW,edit3,ued3_,ulen3
			invoke to_UTF8,ued3_,ued3
			free$  ued3_
			
			mov    ued4_, alloc$(ulen4)
			mov    ued4, alloc$(ulen4)
			invoke GetWindowTextW,edit4,ued4_,ulen4
			invoke to_UTF8,ued4_,ued4
			free$  ued4_
			
			invoke lstrcpy,ued,ADDR comm1
			invoke lstrcat,ued,ued1
			invoke lstrcat,ued,ADDR comm3
			invoke lstrcat,ued,ued2
			invoke lstrcat,ued,ADDR comm3
			invoke lstrcat,ued,ued3
			invoke lstrcat,ued,ADDR comm3
			invoke lstrcat,ued,ued4
			invoke lstrcat,ued,ADDR comm2
			free$  ued1
			free$  ued2
			free$  ued3
			free$  ued4
			invoke sqlite3_exec,datab,ued,ADDR CallBack,0,ADDR errMsg
			.if eax==SQLITE_OK
				invoke SendMessage,edit1,WM_SETTEXT,0,CADD(0)
				invoke SendMessage,edit2,WM_SETTEXT,0,CADD(0)
				invoke SendMessage,edit3,WM_SETTEXT,0,CADD(0)
				invoke SendMessage,edit4,WM_SETTEXT,0,CADD(0)
				invoke SQL_show_number
			.else
				invoke MessageBox,hWnd,errMsg,CADD("Error!.."),MB_OK
			.endif
			free$ ued
@@:			
		.endif	
	.ELSEIF uMsg==WM_CREATE
		invoke DoOpenProfile	
		invoke GetAppPath,ADDR path
		invoke lstrcat,ADDR path,CADD("skins\")
		invoke lstrcat,ADDR path,ADDR skin
		mov    hmem1,FUNC(DoLoad,hWnd,ADDR path,CADD("\left_bor.bmp"),20,400)
		mov    hmem2,FUNC(DoLoad,hWnd,ADDR path,CADD("\right_bor.bmp"),20,400)
		mov    hmem3,FUNC(DoLoad,hWnd,ADDR path,CADD("\bottom_bor.bmp"),360,20)
		mov    hmem4,FUNC(DoLoad,hWnd,ADDR path,CADD("\caption.bmp"),360,20)
		mov    hmem5,FUNC(DoLoad,hWnd,ADDR path,CADD("\search_bor_l.bmp"),20,20)
		mov    hmem6,FUNC(DoLoad,hWnd,ADDR path,CADD("\search_bor_r.bmp"),20,20)
		invoke DoLoadBut,hWnd,344,4,ADDR path,CADD("\min_up.bmp"),CADD("\min_ov.bmp"),CADD("\min_down.bmp"),100
		invoke DoLoadBut,hWnd,360,4,ADDR path,CADD("\close_up.bmp"),CADD("\close_ov.bmp"),CADD("\close_down.bmp"),101
		mov    edit1,FUNC(CreateWindowExW,0,uni$("EDIT"),0,ES_AUTOHSCROLL+WS_VISIBLE+WS_CHILD,40,40,140,20,hWnd,20,hInstance,0)
		mov    edit2,FUNC(CreateWindowExW,0,uni$("EDIT"),0,ES_AUTOHSCROLL+WS_VISIBLE+WS_CHILD,40,70,140,20,hWnd,21,hInstance,0)
		mov    edit3,FUNC(CreateWindowExW,0,uni$("EDIT"),0,ES_AUTOHSCROLL+WS_VISIBLE+WS_CHILD,40,100,140,20,hWnd,22,hInstance,0)
		mov    edit4,FUNC(CreateWindowExW,0,uni$("EDIT"),0,ES_AUTOHSCROLL+WS_VISIBLE+WS_CHILD,40,130,140,20,hWnd,23,hInstance,0)
		mov    edit5,FUNC(CreateWindowExW,0,uni$("EDIT"),0,ES_AUTOHSCROLL+WS_VISIBLE+WS_CHILD,40,160,100,20,hWnd,24,hInstance,0)
		mov    edit6,FUNC(CreateWindowExW,0,uni$("EDIT"),0,ES_MULTILINE+WS_VISIBLE+WS_CHILD+WS_HSCROLL+WS_VSCROLL,40,200,140,100,hWnd,25,hInstance,0)
		mov    OldWndProc,FUNC(SetWindowLong,edit5,GWL_WNDPROC,ADDR edit_proc)
		mov    numb,FUNC(CreateWindowEx,0,CADD("STATIC"),0,SS_CENTER+WS_VISIBLE+WS_CHILD,300,40,60,20,hWnd,0,hInstance,0)
		mov    but,FUNC(CreateWindowEx,WS_EX_CLIENTEDGE,CADD("BUTTON"),CADD("Enter"),WS_VISIBLE+WS_CHILD,200,40,60,20,hWnd,2000,hInstance,0)
		mov    but1,FUNC(CreateWindowEx,WS_EX_CLIENTEDGE,CADD("BUTTON"),CADD(":["),WS_VISIBLE+WS_CHILD,200,240,40,20,hWnd,2001,hInstance,0)
		mov    but2,FUNC(CreateWindowEx,WS_EX_CLIENTEDGE,CADD("BUTTON"),CADD(":]"),WS_VISIBLE+WS_CHILD,250,240,40,20,hWnd,2002,hInstance,0)
		mov    fon ,FUNC(CreateFontIndirect,ADDR LF)
		invoke SendMessage,edit1,WM_SETFONT,fon,1
		invoke SendMessage,edit2,WM_SETFONT,fon,1
		invoke SendMessage,edit3,WM_SETFONT,fon,1
		invoke SendMessage,edit4,WM_SETFONT,fon,1
		invoke SendMessage,edit5,WM_SETFONT,fon,1
		invoke SendMessage,edit6,WM_SETFONT,fon,1
		invoke SendMessage,but,WM_SETFONT,fon,1
		invoke SendMessage,but1,WM_SETFONT,fon,1
		invoke SendMessage,but2,WM_SETFONT,fon,1
		invoke SendMessage,but3,WM_SETFONT,fon,1
		invoke SendMessage,numb,WM_SETFONT,fon,1
		invoke SendMessage,edit1,WM_SETTEXT,0,CADD("Dark_Metal")		
		;-------------------------------------------------------
		invoke sqlite3_open,ADDR DBName,ADDR datab
		.if eax==SQLITE_ERROR
			invoke MessageBox,hWnd,CADD("Something went wrong!"),CADD("Error"),MB_OK
		.endif
		invoke sqlite3_exec,datab,CADD("CREATE TABLE moby_dic ( phrase TEXT PRIMARY KEY, trans TEXT, examp TEXT, asoc TEXT);"),ADDR CallBack,0,ADDR errMsg
		.if eax==SQLITE_ERROR
			invoke lstrcmp,errMsg,CADD("table moby_dic already exists")
			jz @F
			invoke MessageBox,hWnd,errMsg,CADD("Error"),MB_OK
			@@:
		.endif
		invoke SQL_show_number
		invoke SetFocus,edit1
		;---------------------
	.ELSEIF uMsg==WM_LBUTTONDOWN
		HIWORD lParam
		.if eax <= 20
			invoke SendMessage,hWnd,WM_NCLBUTTONDOWN,HTCAPTION,lParam
		.endif
	.ELSEIF uMsg==WM_RBUTTONDOWN
		LOWORD lParam
		mov    mpt.x,eax
		HIWORD lParam
		mov    mpt.y,eax
		invoke ClientToScreen,hWnd,ADDR mpt
		invoke TrackPopupMenuEx,menu1,TPM_LEFTALIGN,mpt.x,mpt.y,hWnd,0

	.ELSEIF uMsg==WM_ERASEBKGND	
		return 1
	.ELSEIF uMsg==WM_PAINT
		invoke BeginPaint,hWnd,ADDR ps
		invoke SetBkColor,   ps.hdc,0
		invoke ExtTextOut,   ps.hdc,0,0,ETO_OPAQUE,ADDR ps.rcPaint,0,0,0
		invoke BitBlt,ps.hdc,0,0,20,400,hmem1,0,0,SRCCOPY
		invoke BitBlt,ps.hdc,380,0,20,400,hmem2,0,0,SRCCOPY
		invoke BitBlt,ps.hdc,20,380,360,20,hmem3,0,0,SRCCOPY
		invoke BitBlt,ps.hdc,20,0,360,20,hmem4,0,0,SRCCOPY
		;-------------------------------------------------
		invoke BitBlt,ps.hdc,20,40,20,20,hmem5,0,0,SRCCOPY
		invoke BitBlt,ps.hdc,180,40,20,20,hmem6,0,0,SRCCOPY
		invoke BitBlt,ps.hdc,20,70,20,20,hmem5,0,0,SRCCOPY
		invoke BitBlt,ps.hdc,180,70,20,20,hmem6,0,0,SRCCOPY
		invoke BitBlt,ps.hdc,20,100,20,20,hmem5,0,0,SRCCOPY
		invoke BitBlt,ps.hdc,180,100,20,20,hmem6,0,0,SRCCOPY
		invoke BitBlt,ps.hdc,20,130,20,20,hmem5,0,0,SRCCOPY
		invoke BitBlt,ps.hdc,180,130,20,20,hmem6,0,0,SRCCOPY
		invoke BitBlt,ps.hdc,20,160,20,20,hmem5,0,0,SRCCOPY
		invoke BitBlt,ps.hdc,140,160,20,20,hmem6,0,0,SRCCOPY		
		
		invoke EndPaint,hWnd,ADDR ps	
	.ELSE
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	.ENDIF
	
	xor eax,eax
	ret
WndProc endp

to_UTF8 proc sour:DWORD,dest:DWORD
	LOCAL b1:BYTE
	LOCAL b2:BYTE
	
	xor    eax,eax
	mov    esi,sour
	mov    edi,dest
@@:
	mov    ax,word ptr [esi]
	;cmp    ax,0FFFFh
	;jg     _4bytes
	cmp    ax,0
	je     fin
	cmp    ax,07FFh
	jg     _3bytes
	cmp    ax,007Fh
	jg     _2bytes
	;----1_byte
	mov    byte ptr [edi],al
	inc    edi
	jmp    next_char
_2bytes:
	mov    ebx,080h
	mov    ecx,eax
	and    ecx,3Fh
	or     ecx,ebx
	mov    edx,ecx
	;---------------------
	mov    ebx,0C0h
	mov    ecx,eax
	shr    ecx,6
	or     ecx,ebx
	;---------------------
	mov    byte ptr [edi],cl
	mov    byte ptr [edi+1],dl
	add    edi,2
	jmp    next_char
_3bytes:
	mov    ebx,080h
	mov    ecx,eax
	and    ecx,3Fh
	or     ecx,ebx
	mov    b1,cl
	;--------------
	mov    ebx,080h
	mov    ecx,eax
	and    ecx,0FFFh
	shr    ecx,6
	or     ecx,ebx
	mov    b2,cl
	;--------------
	mov    ebx,0E0h
	mov    ecx,eax
	shr    ecx,12
	or     ecx,ebx
	;--------------
	mov    byte ptr [edi],cl
	mov    cl,b2
	mov    byte ptr [edi+1],cl
	mov    cl,b1
	mov    byte ptr [edi+2],cl
	add    edi,3
_4bytes: ;WE'LL_IGNORE_IT_AS_MOST_OF_API_DOES
next_char:
	add    esi,2
	jmp    @B
fin:
	mov    byte ptr [edi],0	
	
	ret

to_UTF8 endp

UTF8_to proc sour:DWORD,dest:DWORD
	
	xor    eax,eax
	mov    esi,sour
	mov    edi,dest
@@:
	mov    al,byte ptr [esi]
	;cmp    ax,0FFFFh
	;jg     _4bytes
	cmp    al,0
	je     fin
	mov    cl,al
	and    cl,0E0h
	cmp    cl,0E0h
	je     _3bytes
	mov    cl,al
	and    cl,0C0h
	cmp    cl,0C0h
	je     _2bytes
	;----1_byte
	mov    byte ptr [edi],al
	mov    byte ptr [edi+1],0
	inc    esi
	jmp    next_char
_2bytes:
	mov    cl,al
	shl    cl,6
	mov    bl,byte ptr [esi+1]
	and    bl,3Fh
	or     cl,bl
	mov    byte ptr [edi],cl    
	;-------------------------
	mov    cl,al
	and    cl,1Fh
	shr    cl,2
	mov    byte ptr [edi+1],cl
	add    esi,2
	jmp    next_char
_3bytes:
	mov    cl,byte ptr [esi+1]
	and    cl,3
	shl    cl,6
	mov    bl,byte ptr [esi+2]
	and    bl,3Fh
	or     cl,bl
	mov    byte ptr [edi],cl
	;-------------------------
	mov    cl,byte ptr [esi+1]
	and    cl,3Fh
	shr    cl,2
	mov    bl,byte ptr [esi]
	shl    bl,4
	or     cl,bl
	mov    byte ptr [edi+1],cl
	add    esi,3
_4bytes: ;WE'LL_IGNORE_IT_AS_MOST_OF_API_DOES
next_char:
	add    edi,2
	jmp    @B
fin:
	mov    byte ptr [edi],0
	mov    byte ptr [edi+1],0	
		
	ret

UTF8_to endp

create_region proc hWnd:DWORD
	LOCAL rgn1:DWORD
	LOCAL rgn2:DWORD
	
	mov rgn1,FUNC(CreateRectRgn,0,0,400,400)
	mov rgn2,FUNC(CreateRectRgn,200,70,360,80)
	invoke CombineRgn,rgn1,rgn1,rgn2,RGN_XOR
	mov rgn2,FUNC(CreateRectRgn,350,80,360,230)
	invoke CombineRgn,rgn1,rgn1,rgn2,RGN_XOR
	mov rgn2,FUNC(CreateRectRgn,200,220,350,230)
	invoke CombineRgn,rgn1,rgn1,rgn2,RGN_XOR
	mov rgn2,FUNC(CreateRectRgn,200,90,210,220)
	invoke CombineRgn,rgn1,rgn1,rgn2,RGN_XOR
	mov rgn2,FUNC(CreateRectRgn,210,90,340,100)
	invoke CombineRgn,rgn1,rgn1,rgn2,RGN_XOR
	mov rgn2,FUNC(CreateRectRgn,330,100,340,210)
	invoke CombineRgn,rgn1,rgn1,rgn2,RGN_XOR
	mov rgn2,FUNC(CreateRectRgn,220,200,330,210)
	invoke CombineRgn,rgn1,rgn1,rgn2,RGN_XOR
	mov rgn2,FUNC(CreateRectRgn,220,110,230,200)
	invoke CombineRgn,rgn1,rgn1,rgn2,RGN_XOR
	mov rgn2,FUNC(CreateRectRgn,230,110,320,120)
	invoke CombineRgn,rgn1,rgn1,rgn2,RGN_XOR
	mov rgn2,FUNC(CreateRectRgn,310,120,320,190)
	invoke CombineRgn,rgn1,rgn1,rgn2,RGN_XOR
	mov rgn2,FUNC(CreateRectRgn,240,180,310,190)
	invoke CombineRgn,rgn1,rgn1,rgn2,RGN_XOR
	mov rgn2,FUNC(CreateRectRgn,240,130,250,180)
	invoke CombineRgn,rgn1,rgn1,rgn2,RGN_XOR
	mov rgn2,FUNC(CreateRectRgn,250,130,300,140)
	invoke CombineRgn,rgn1,rgn1,rgn2,RGN_XOR
	mov rgn2,FUNC(CreateRectRgn,290,140,300,170)
	invoke CombineRgn,rgn1,rgn1,rgn2,RGN_XOR
	mov rgn2,FUNC(CreateRectRgn,260,160,290,170)
	invoke CombineRgn,rgn1,rgn1,rgn2,RGN_XOR
	mov rgn2,FUNC(CreateRectRgn,260,150,270,160)
	invoke CombineRgn,rgn1,rgn1,rgn2,RGN_XOR

	invoke SetWindowRgn,hWnd,rgn1,1
	ret

create_region endp

SQL_show_number proc
	LOCAL errMsg:DWORD
	invoke sqlite3_exec,datab,CADD("SELECT COUNT(*) FROM moby_dic"),ADDR call_show_number,0,ADDR errMsg
	.if eax==SQLITE_ERROR
		invoke MessageBox,0,errMsg,CADD("Error"),MB_OK
	.endif
	ret

SQL_show_number endp

call_show_number proc not_used:DWORD,argc:DWORD,argv:DWORD,azColName:DWORD

	mov   eax,argv
	mov   eax,[eax]
	invoke SendMessage,numb,WM_SETTEXT,0,eax

	ret
call_show_number endp

edit_proc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL search_buf[512]:BYTE
	LOCAL buf[1024]:BYTE
	LOCAL errMsg:DWORD
	LOCAL u_len:DWORD,s_buf:DWORD,con_buf:DWORD,e_buf:DWORD
	LOCAL ustr1:DWORD
	LOCAL ustr2:DWORD
	.if uMsg==WM_CHAR
		invoke CallWindowProc,OldWndProc,hWnd,uMsg,wParam,lParam
		invoke GetWindowTextLengthW,hWnd
		shl    eax,1
		add    eax,128
		mov    u_len,eax
		mov    e_buf,alloc$(u_len)
		mov    s_buf,alloc$(u_len)
		mov    con_buf,alloc$(u_len)
		invoke GetWindowTextW,hWnd,con_buf,u_len
		invoke to_UTF8,con_buf,e_buf
		free$  con_buf
		invoke lstrcpy,s_buf,ADDR comm_1
		invoke lstrcat,s_buf,e_buf
		invoke lstrcat,s_buf,ADDR comm_2
		free$  e_buf
		;invoke MessageBoxW,hWnd,ADDR buf,0,MB_OK
		invoke sqlite3_exec,datab,s_buf,ADDR CallBack,0,ADDR errMsg
		.if eax==SQLITE_ERROR
			invoke MessageBox,hWnd,errMsg,CADD("Error!.."),MB_OK
		.endif
		free$ s_buf
		return 0
	.elseif uMsg==WM_ERASEBKGND	
		return 1
	.endif
	invoke CallWindowProc,OldWndProc,hWnd,uMsg,wParam,lParam
	ret

edit_proc endp

CallBack proc not_used:DWORD,argc:DWORD,argv:DWORD,azColName:DWORD
	LOCAL count:DWORD
	LOCAL buf:DWORD,buf2:DWORD
	mov   count,0
	
	mov   buf,alloc$(4096)
	mov   buf2,alloc$(8192)
	invoke lstrcpy,buf,CADD(0)
@@:	
	mov   eax,argv
	mov   ebx,count
	shl   ebx,2
	add   eax,ebx
	mov   eax,[eax]
	invoke lstrcat,buf,eax
	invoke lstrcat,buf,ADDR LF_
	mov   eax,argc
	inc   count
	cmp   count,eax
	jne @B
	invoke UTF8_to,buf,buf2
	invoke SetWindowTextW,edit6,buf2
	free$  buf
	free$  buf2
	return 0

CallBack endp

Search4Skins proc path:DWORD
	
	LOCAL _path[512]:BYTE
	;LOCAL x_pt[512]:BYTE
	LOCAL F_D:WIN32_FIND_DATA
	LOCAL find_h:DWORD
	LOCAL ic_ID:DWORD
	LOCAL ID:DWORD
	
	invoke lstrcpy,ADDR _path,path
	invoke lstrcat,ADDR _path,CADD("\*.*")
	mov    ID,1000
	invoke FindFirstFile,ADDR _path,ADDR F_D
	mov    find_h,eax
	xor    ecx,ecx
	cmp    eax,INVALID_HANDLE_VALUE
	je     exit
@@:	
    invoke lstrcmp,ADDR F_D.cFileName,CADD(".")
    cmp eax,0
    je  next
    invoke lstrcmp,ADDR F_D.cFileName,CADD("..")
    cmp eax,0
    je  next
	.if F_D.dwFileAttributes==FILE_ATTRIBUTE_DIRECTORY
		invoke AppendMenu,menu1,MF_UNCHECKED,ID,ADDR F_D.cFileName
		inc ID
	.endif
next:
    invoke FindNextFile,find_h,ADDR F_D
    or     eax,eax
    jnz    @B 
	invoke FindClose,find_h
exit: 
	xor    eax,eax    
	ret

Search4Skins endp

DoLoadBut PROC hw:DWORD,x:DWORD,y:DWORD,path:DWORD,path1:DWORD,path2:DWORD,path3:DWORD,ID:DWORD
	LOCAL _path1[512]:BYTE
	LOCAL _path2[512]:BYTE
	LOCAL _path3[512]:BYTE
	
	invoke lstrcpy,ADDR _path1,path
	invoke lstrcpy,ADDR _path2,path
	invoke lstrcpy,ADDR _path3,path
	invoke lstrcat,ADDR _path1,path1
	invoke lstrcat,ADDR _path2,path2
	invoke lstrcat,ADDR _path3,path3
	invoke BmpBut,hw,x,y,ADDR _path1,ADDR _path2,ADDR _path3,ID
	ret
DoLoadBut ENDP

DoLoad PROC hw:DWORD,path:DWORD,detail:DWORD,x:DWORD,y:DWORD
	LOCAL _path[512]:BYTE
	LOCAL dc:DWORD
	LOCAL _hmem:DWORD
	LOCAL bmp:DWORD
	LOCAL hbit:DWORD
	invoke lstrcpy,ADDR _path,path
	invoke lstrcat,ADDR _path,detail

	mov    dc,  FUNC(GetDC,hw)
	mov    _hmem,FUNC(CreateCompatibleDC,dc)
	mov    hbit,FUNC(CreateCompatibleBitmap,dc,x,y)
	mov    hold,FUNC(SelectObject,_hmem,eax)
	mov     bmp,FUNC(LoadImage,0,ADDR _path,IMAGE_BITMAP,0,0,LR_DEFAULTCOLOR+LR_LOADFROMFILE)
	mov    hold,FUNC(SelectObject,_hmem,bmp) 
	invoke ReleaseDC,hw,dc
	invoke DeleteObject,hbit
	invoke DeleteObject,bmp
	mov    eax,_hmem
	ret
DoLoad ENDP

DoOpenProfile PROC
	LOCAL path[512]:BYTE
	
	invoke GetAppPath,ADDR path
	invoke lstrcat,ADDR path,CADD("moby_dic.ini")
	
	invoke GetPrivateProfileString,CADD("EDITOR"),CADD("font_face"),CADD("default"),ADDR skin,128,ADDR path
	xor eax,eax
	ret
DoOpenProfile ENDP

end start
